import processing.sound.*;
PImage bg;
AudioIn input;
Amplitude volumeAnalyzer;

//float micVolume;
float micVolumeTarget;
//float easing;

bird b = new bird();
pillar[] p = new pillar[3];
boolean end=false; //game is over or not, false is over
boolean intro=true; //show which information
int score=0;

void setup(){
  size(500,600);
  
  //definition of the obstacle
  for(int i = 0;i<3;i++){
    p[i]=new pillar(i);
  }

  //definition of the input of sound
  input = new AudioIn(this, 0);
  input.start();
  
  //definition of the analyse of the input of sound
  volumeAnalyzer = new Amplitude(this);
  volumeAnalyzer.input(input);
  
  bg = loadImage("flappybird.jpg");
}

void draw(){
  background(bg);
  if(end){
    b.jump();
    b.move();
  }
  b.drawBird();
  if(end){
    b.drag();
    b.move();
  }
  b.checkCollisions();
  for(int i = 0;i<3;i++){
    p[i].drawPillar();
    p[i].checkPosition();
  }
  fill(0);
  stroke(255);
  textSize(32);
  if(end){
  rect(20,20,100,50);
  fill(255);
  text(score,30,58);
  }else{
  rect(150,100,200,50);
  rect(150,200,200,50);
  fill(255);
  if(intro){
    text("Voice    Bird",155,140);
    text("Click to Play",155,240);
  }else{
    text("game over",170,140);
    text("score",180,240);
    text(score,280,240);
  }
  }
}
class bird{
  float xPos,yPos,ySpeed;
  bird(){
  xPos = 250;
  yPos = 300;
  }
  void drawBird(){
    stroke(0);
    noFill();
    strokeWeight(2);
    fill(255,215,0);
    ellipse(xPos,yPos,30,30);
    fill(255);
    ellipse(xPos+12,yPos-7,15,10);
    point(xPos+14,yPos-8);
    fill(178,34,34);
    ellipse(xPos+12,yPos+4,20,5);
    ellipse(xPos+12,yPos+8,20,5);
    
  }
  void jump(){
     micVolumeTarget=int(map(volumeAnalyzer.analyze(), 0, 1, 0, 40));
     //micVolume += (micVolumeTarget-micVolume) * easing;
     ySpeed = -micVolumeTarget;
  }
  void drag(){
     if(frameCount < 1000){
        ySpeed+=1;
     }
     else if(frameCount >= 1000 && frameCount < 3000){
       ySpeed+=2;
     }
     else if(frameCount >= 3000){
       ySpeed+=4;
     }
  }
  void move(){
     yPos+=ySpeed; 
     for(int i = 0;i<3;i++){
       if(frameCount < 1000){
          p[i].xPos-=1;
       }
       else if(frameCount >= 1000 && frameCount < 3000){
          p[i].xPos-=2;
       }
       else if(frameCount >= 3000){
          p[i].xPos-=4;
       }
   }
  }
  void checkCollisions(){
     if(yPos>600){
       end=false;
     }
     for(int i = 0;i<3;i++){
       if((xPos<p[i].xPos+5&&xPos>p[i].xPos-5)&&(yPos<p[i].opening-55||yPos>p[i].opening+55)){
         end=false; 
       }
     }
   } 
}

class pillar{
  float xPos, opening;
  boolean cashed = false;
  pillar(int i){
    xPos = 100+(i*200);
    opening = random(300)+150;
  }
  void drawPillar(){
    //line(xPos,0,xPos,opening-50);  
    //line(xPos,opening+50,xPos,800);
    fill(0,235,0);
    rect(xPos-10,0,20,opening-90);
    rect(xPos-20,opening-90,40,20,7);
    rect(xPos-20,opening+70,40,20,7);
    rect(xPos-10,opening+90,20,730-opening);
  }
 void checkPosition(){
   if(xPos<0){
     xPos+=(200*3);
     opening = random(300)+150;
     cashed=false;
   } 
   if(xPos<250&&cashed==false){
     cashed=true;
     score++; 
   }
 }
}

void reset(){
  end=true;
  score=0;
  b.yPos=300;
  for(int i = 0;i<3;i++){
    p[i].xPos+=550;
    p[i].cashed = false;
  }
}

void mousePressed(){
  intro=false;
  if(end==false){
    reset();
  }
}
 